From c8951b36cd04df279fdeaabdd29b87929fbb6fbc Mon Sep 17 00:00:00 2001
From: Raghav Gururajan <raghavgururajan@disroot.org>
Date: Fri, 1 May 2020 09:36:57 -0400
Subject: [PATCH 2/2] gnu: zathura: Move to pwmt module.

Moved variable from pdf.scm to pwmt.scm, for being part of pwmt project.
Added extra dependencies and arguments for additional features.
Updated synopsis and description.
Made some cosmetic changes in the definition.

* gnu/packages/pdf.scm (zathura): Remove variable.
* gnu/packages/pwmt.scm (zathura): Add variable.
---
 gnu/packages/pdf.scm  | 58 --------------------------------
 gnu/packages/pwmt.scm | 78 +++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 78 insertions(+), 58 deletions(-)

diff --git a/gnu/packages/pdf.scm b/gnu/packages/pdf.scm
index 71b8177582..ff75e1ed55 100644
--- a/gnu/packages/pdf.scm
+++ b/gnu/packages/pdf.scm
@@ -577,64 +577,6 @@ by using the @code{mupdf} rendering library.")
 by using the poppler rendering engine.")
     (license license:zlib)))
 
-(define-public zathura
-  (package
-    (name "zathura")
-    (version "0.4.5")
-    (source (origin
-              (method url-fetch)
-              (uri
-               (string-append "https://pwmt.org/projects/zathura/download/zathura-"
-                              version ".tar.xz"))
-              (sha256
-               (base32
-                "0b3nrcvykkpv2vm99kijnic2gpfzva520bsjlihaxandzfm9ff8c"))))
-    (native-inputs `(("pkg-config" ,pkg-config)
-                     ("gettext" ,gettext-minimal)
-                     ("glib:bin" ,glib "bin")
-
-                     ;; For building documentation.
-                     ("python-sphinx" ,python-sphinx)
-
-                     ;; For building icons.
-                     ("librsvg" ,librsvg)
-
-                     ;; For tests.
-                     ("check" ,check)
-                     ("xorg-server" ,xorg-server-for-tests)))
-    (inputs `(("sqlite" ,sqlite)))
-    ;; Listed in 'Requires.private' of 'zathura.pc'.
-    (propagated-inputs `(("cairo" ,cairo)
-                         ("girara" ,girara)))
-    (native-search-paths
-     (list (search-path-specification
-            (variable "ZATHURA_PLUGINS_PATH")
-            (files '("lib/zathura")))))
-    (build-system meson-build-system)
-    (arguments
-     `(#:phases (modify-phases %standard-phases
-                  (add-before 'check 'start-xserver
-                    ;; Tests require a running X server.
-                    (lambda* (#:key inputs #:allow-other-keys)
-                      (let ((xorg-server (assoc-ref inputs "xorg-server"))
-                            (display ":1"))
-                        (setenv "DISPLAY" display)
-
-                        ;; On busy machines, tests may take longer than
-                        ;; the default of four seconds.
-                        (setenv "CK_DEFAULT_TIMEOUT" "20")
-
-                        ;; Don't fail due to missing '/etc/machine-id'.
-                        (setenv "DBUS_FATAL_WARNINGS" "0")
-                        (zero? (system (string-append xorg-server "/bin/Xvfb "
-                                                      display " &")))))))))
-    (home-page "https://pwmt.org/projects/zathura/")
-    (synopsis "Lightweight keyboard-driven PDF viewer")
-    (description "Zathura is a customizable document viewer.  It provides a
-minimalistic interface and an interface that mainly focuses on keyboard
-interaction.")
-    (license license:zlib)))
-
 (define-public podofo
   (package
     (name "podofo")
diff --git a/gnu/packages/pwmt.scm b/gnu/packages/pwmt.scm
index 3e986c3656..be9613bbf8 100644
--- a/gnu/packages/pwmt.scm
+++ b/gnu/packages/pwmt.scm
@@ -26,11 +26,18 @@
   #:use-module (gnu packages)
   #:use-module (gnu packages check)
   #:use-module (gnu packages documentation)
+  #:use-module (gnu packages file)
+  #:use-module (gnu packages freedesktop)
   #:use-module (gnu packages gettext)
   #:use-module (gnu packages glib)
   #:use-module (gnu packages gnome)
   #:use-module (gnu packages gtk)
+  #:use-module (gnu packages linux)
   #:use-module (gnu packages pkg-config)
+  #:use-module (gnu packages python)
+  #:use-module (gnu packages python-xyz)
+  #:use-module (gnu packages sphinx)
+  #:use-module (gnu packages sqlite)
   #:use-module (gnu packages web)
   #:use-module (gnu packages xorg)
   #:use-module (gnu packages xdisorg)
@@ -99,3 +106,74 @@ application, an input bar that is used to execute commands of the
 application and the status bar which provides the user with current
 information.")
     (license license:zlib)))
+
+(define-public zathura
+  (package
+    (name "zathura")
+    (version "0.4.5")
+    (source
+     (origin
+       (method url-fetch)
+       (uri
+        (string-append "https://pwmt.org/projects/" name "/download/"
+                       name "-" version ".tar.xz"))
+       (sha256
+        (base32
+         "0b3nrcvykkpv2vm99kijnic2gpfzva520bsjlihaxandzfm9ff8c"))))
+    (build-system meson-build-system)
+    (arguments
+     `(#:glib-or-gtk? #t                ; To compile schemas
+       #:phases
+       (modify-phases %standard-phases
+         (add-before 'check 'start-xserver
+           ;; Tests require a running X server.
+           (lambda* (#:key inputs #:allow-other-keys)
+             (let
+                 ((xorg-server (assoc-ref inputs "xorg-server"))
+                  (display ":1"))
+               (setenv "DISPLAY" display)
+               ;; On busy machines, tests may take longer than
+               ;; the default of four seconds.
+               (setenv "CK_DEFAULT_TIMEOUT" "20")
+               ;; Don't fail due to missing '/etc/machine-id'.
+               (setenv "DBUS_FATAL_WARNINGS" "0")
+               (zero?
+                (system
+                 (string-append xorg-server "/bin/Xvfb "
+                                display " &")))))))))
+    (native-inputs
+     `(("check" ,check)                 ; For tests
+       ("desktop-file-utils" ,desktop-file-utils)
+       ("doxygen" ,doxygen)             ; For docs
+       ("gettext" ,gettext-minimal)
+       ("glib:bin" ,glib "bin")
+       ("librsvg" ,librsvg)             ; For icons
+       ("pkg-config" ,pkg-config)
+       ("python-breathe" ,python-breathe)                   ; For docs
+       ("python-sphinx-rtd-theme" ,python-sphinx-rtd-theme) ; For docs
+       ("python-sphinx" ,python-sphinx)                     ; For docs
+       ("xorg-server" ,xorg-server-for-tests))) ; For tests
+    (inputs
+     `(("appstream-glib" ,appstream-glib)
+       ("cairo" ,cairo)
+       ("file" ,file)                   ; For mime-type detection
+       ("glib" ,glib)
+       ("json-c" ,json-c)          ; For configuration dumping support
+       ("gtk+" ,gtk+)
+       ("libnotify" ,libnotify)         ; For notification support
+       ("libseccomp" ,libseccomp)       ; For sandbox support
+       ("sqlite" ,sqlite)))             ; For database backend
+    (propagated-inputs
+     `(("girara" ,girara)))
+    (native-search-paths
+     (list
+      (search-path-specification
+       (variable "ZATHURA_PLUGINS_PATH")
+       (files '("lib/zathura")))))
+    (synopsis "Document Viewer")
+    (description "Zathura is a highly customizable and functional document
+viewer based on the girara user interface library and several document
+libraries.  It currently supports multiple back-ends (PostScript, PDF, EPUB,
+DjVu and ComicBook) via plugins.")
+    (home-page "https://pwmt.org/projects/zathura/")
+    (license license:zlib)))
-- 
2.26.2